Get Consolidated Vulnerability Data

GET /pci/vuln/consolidated

Use this API to generate and export consolidated vulnerability data. The vulnerability data report contains details for all vulnerabilities in a single API request. The vulnerability reports are generated in CSV (regular) and CSV (detailed) formats.

Permissions required - You must have an active PCI merchant account.

Input ParametersInput Parameters

The following are the input parameters required for generating and exporting consolidated vulnerability data.

Input Parameter Mandatory/Optional Data Type Description
offset Optional Integer Specify the start record number of a scan to be considered for the request.
Valid values: Greater than 1
Default value: 1
limit Optional Integer The maximum number of records processed for the request, starting at the record number specified by the offset parameter. Limit value must always be greater than 0. If you specify a value 0 for the parameter, the request fails.
Valid values: Between 1-1000
Default value: 100
sortBy Optional String Specify the criterion to sort the vulnerabilities. 
Valid values:
  • ip - Sort vulnerabilities by IP address
  • title - Sort vulnerabilities by title
  • severity - Sort vulnerabilities by severity score
  • scandate - Sort vulnerabilities by scan date
  • scanModule - Sort vulnerabilities by scan application
Default value: ip
sortOrder Optional String Specify the order to sort the vulnerabilities.
Valid values: DESC and ASC (For descending order)
Default value: ASC (For ascending order)
ip Optional String Specify the valid IP address, CIDR, or IP range to view related vulnerabilities.
dns Optional String Specify the DNS hostname to view the related vulnerabilities.
qid Optional String Specify the vulnerability ID (QID) to view the associated vulnerabilities. 
title Optional String Specify the vulnerability title to search for vulnerabilities. The vulnerability titles are case sensitive. This parameter returns all vulnerabilities that exactly or partially match the specified title.
severity Optional String Provide a comma-separated list of severity values to search for vulnerabilities at certain severity levels.
Valid values: CONFIRMED_HIGH, CONFIRMED_MED, CONFIRMED_LOW, POTENTIAL_HIGH, POTENTIAL_MED, POTENTIAL_LOW
falsePositive Optional String Specify the false positive status view the associated vulnerabilities.
Valid values: Requested, Rejected, Expired
pciFailVulns Optional Boolean Search for vulnerabilities by PCI compliance status.
Valid values: true, false
Default value: false. By default, it lists all the vulnerabilities irrespective of their PCI compliance status.
When set to true, it lists vulnerabilities with failed PCI compliance status.
fpSubmissionList Optional Boolean Specify this value to generate a list of QIDs for which you can submit false positive requests.
Valid values: true, false
Default value: False. By default, it does not list QIDs for false submission.
If set to true, the pciFailVulns parameter must be set to true.
downloadFormat Optional String Specify the download format for consolidated vulnerability reports.
Valid values:
  • csv - Regular vulnerability report with 16 columns.
    File name format: PCIVulnReport-YYYYMMDD.csv
  • csv_detailed - Regular vulnerability report with 26 columns. 
    File name format: PCIVulnReport-Detailed-YYYYMMDD.csv

Sample - Generate Consolidated Vulnerability DataSample - Generate Consolidated Vulnerability Data

The following sample illustrates generating consolidated vulnerability data.

API Request


    curl --location 'https://pci-api.qualys.com/pci/vuln/consolidated?limit=2' \
    --header 'X-Requested-With: test' \
    -u '<user_login>'
    

API Response

{
  "responseApiVersion": "LATEST - V1",
  "data": {
    "totalCount": 302843,
    "fetchRange": "1-2",
    "merchantVulnConsolidatedList": [
      {
        "id": 1347858,
        "qid": 82003,
        "title": "ICMP Timestamp Request",
        "pciCompliant": "Pass",
        "severity": "Confirmed Low",
        "ip": "10.10.10.10",
        "dns": "def.p01.eng.in01.qualys.com...",
        "dateLastScanned": "01/14/2025",
        "fpStatus": "NA",
        "scanModule": "PCI",
        "operatingSystem": "NetScaler",
        "qualysSeverity": 1,
        "cvssBase": "null",
        "cvssTemporal": "null",
        "category": "TCP/IP",
        "port": null,
        "service": "TCP/IP",
        "protocol": null,
        "bugTraqList": [],
        "cveList": [],
        "vendorReferenceList": [],
        "dateLastUpdate": "May 28, 2025 at 12:00 AM GMT",
        "threat": "ICMP (Internet Control and Error Message Protocol) is a protocol encapsulated in IP packets...",
        "impact": "Unauthorized users can obtain information about your network by sending ICMP timestamp packets.",
        "solution": "You can filter ICMP messages of type Timestamp and Timestamp Reply at the firewall level.",
        "patch": null,
        "result": "Timestamp of host (network byte ordering): 12:10:11 GMT"
      },
      {
        "id": 1347859,
        "qid": 34000,
        "title": "TCP Source Port Pass Firewall",
        "pciCompliant": "Fail",
        "severity": "Confirmed Low",
        "ip": "10.10.10.10",
        "dns": "def.p01.eng.in01.qualys.com...",
        "dateLastScanned": "01/14/2025",
        "fpStatus": "Rejected",
        "scanModule": "PCI",
        "operatingSystem": "NetScaler",
        "qualysSeverity": 3,
        "cvssBase": "null",
        "cvssTemporal": "null",
        "category": "Firewall",
        "port": null,
        "service": "Firewall",
        "protocol": null,
        "bugTraqList": [],
        "cveList": [],
        "vendorReferenceList": [],
        "dateLastUpdate": "July 10, 2017 at 12:00 AM GMT",
        "threat": "Your firewall policy seems to let TCP packets with a specific source port pass through.",
        "impact": "Some types of requests can pass through the firewall.",
        "solution": "Make sure that all your filtering rules are correct and strict enough.",
        "patch": null,
        "result": "The host responded 2 times to 4 TCP SYN probes sent to destination port 20 using source port 20."
      }
    ]
  }
}
    

Sample - Export Consolidated Vulnerability Data (CSV Regular Format)Sample - Export Consolidated Vulnerability Data (CSV Regular Format)

The following sample illustrates how to download consolidated vulnerability data in CSV Regular Format.

API Request


    curl -OJ --location 'https://pci-api.qualys.com//pci/vuln/consolidated?downloadFormat=csv&limit=100' \
    --header 'Content-Type: application/zip' \
    --header 'X-Requested-With: test' \
    -u '<user_login>'
    

API Response


    HTTP/1.1 200
    Content-Disposition: attachment; filename=PCIVulnReport-20260420.csv
    Content-Type: text/csv;charset=UTF-8
    Content-Length: 482
    

Sample - Export Consolidated Vulnerability Data (CSV Detailed Format)Sample - Export Consolidated Vulnerability Data (CSV Detailed Format)

The following sample illustrates how to download consolidated vulnerability data in CSV Detailed Format.

API Request


    curl -OJ --location 'https://pci-api.qualys.com//pci/vuln/consolidated?downloadFormat=csv_detailed&limit=100' \
    --header 'Content-Type: application/zip' \
    --header 'X-Requested-With: test' \
    -u '<user_login>'
    

API Response


    HTTP/1.1 200
    Content-Disposition: attachment; filename=PCIVulnReport-Detailed-20260420.csv
    Content-Type: text/csv;charset=UTF-8
    Content-Length: 482